#include <qapplication.h>
#include <qdir.h>
#include <qfileinfo.h>

void traverse( const char* dirname );

void traverse( const char* dirname )
{
  QDir dir( dirname );
  dir.setFilter( QDir::Dirs | QDir::Files | QDir::NoSymLinks );

  const QFileInfoList* fileinfolist = dir.entryInfoList();
  QFileInfoListIterator it( *fileinfolist );
  QFileInfo* fi;
  while( ( fi = it.current() ) ) {
	if( fi->fileName() == "." || fi->fileName() == ".." ) {
	  ++it;
	  continue;
	}
	if( fi->isDir() && fi->isReadable() )
	  traverse( fi->absFilePath() );
	else
	  debug( "%s\n", fi->absFilePath().data() );
  
	++it;
  }

  delete fileinfolist;
}


int main( int argc, char* argv[] )
{
  QApplication a( argc, argv );

  traverse( "/" ); // for Windows, use something like "C:\\"

  return 0;
}

