#include <qapplication.h>
#include <qpushbutton.h>
#include <qlineedit.h>
#include <qradiobutton.h>
#include <qcheckbox.h>

class KillerFilter : public QObject
{
protected:
  bool eventFilter( QObject* object, QEvent* event ) {
	if( event->type() == Event_MouseButtonPress )
	  if( ((QMouseEvent*)event)->button() == RightButton ) {
		delete object;
		return TRUE;
	  }
	  else
		return FALSE;
	else
	  return FALSE;
  }
};
		

int main( int argc, char* argv[] )
{
  QApplication a( argc, argv );

  QWidget* toplevel = new QWidget();
  toplevel->resize( 230, 130 );

  QObject* killerfilter = new KillerFilter();

  QPushButton* pb = new QPushButton( toplevel );
  pb->setGeometry( 10, 10, 100, 50 );
  pb->setText( "Push button" );
  pb->installEventFilter( killerfilter );
  
  QLineEdit* le = new QLineEdit( toplevel );
  le->setGeometry( 10, 70, 100, 50 );
  le->setText( "Line edit" );
  le->installEventFilter( killerfilter );

  QCheckBox* cb = new QCheckBox( toplevel );
  cb->setGeometry( 120, 10, 100, 50 );
  cb->setText( "Check box" );
  cb->installEventFilter( killerfilter );

  QRadioButton* rb = new QRadioButton( toplevel );
  rb->setGeometry( 120, 70, 100, 50 );
  rb->setText( "Radio button" );
  rb->installEventFilter( killerfilter ); 

  a.setMainWidget( toplevel );
  toplevel->show();
  return a.exec();
}
