#include <qapplication.h>
#include <qpushbutton.h>
#include <qslider.h>
#include <qlcdnumber.h>

int main( int argc, char* argv[] )
{
  QApplication myapp( argc, argv );

  QWidget* mywidget = new QWidget();
  mywidget->setGeometry( 400, 300, 170, 150 );
  
  
  QSlider* myslider = new QSlider( 0,                   // minimum value
								   9,                   // maximum value
								   1,                   // step
								   1,                   // initial value
								   QSlider::Horizontal, // orientation
								   mywidget            // parent
								   );
  myslider->setGeometry( 10, 10, 150, 30 );

  QLCDNumber* mylcdnum = new QLCDNumber( 1,        // number of digits 
										 mywidget // parent
										 );
  mylcdnum->setGeometry( 60, 50, 50, 50 );
  mylcdnum->display( 1 ); // display initial value

  // connect slider and number display
  QObject::connect( myslider, SIGNAL( valueChanged( int ) ), 
					mylcdnum, SLOT( display( int ) ) );

  // create two push buttons for decrementing and 
  // incrementing the slider values
  QPushButton* decrement = new QPushButton( "<", mywidget );
  decrement->setGeometry( 10, 110, 50, 30 );

  QPushButton* increment = new QPushButton( ">", mywidget );
  increment->setGeometry( 110, 110, 50, 30 );
  
  // connect the clicked() signal of the buttons to the slots that 
  // increment and decrement the slider value
  QObject::connect( decrement, SIGNAL( clicked() ),
					myslider, SLOT( subtractStep() ) );
  QObject::connect( increment, SIGNAL( clicked() ),
					myslider, SLOT( addStep() ) );
  
  myapp.setMainWidget( mywidget );
  mywidget->show();
  return myapp.exec();
}
