#include <qfileinfo.h>

int main( int argc, char* argv[] )
{
  QFileInfo fi( "/etc/passwd" ); // use something like "C:\\AUTOEXEC.BAT on windows

  debug( "%s:\n", fi.filePath() );

  if( fi.isFile() )
	debug( "is  a file\n" );
  if( fi.isDir() )
	debug( "is a directory\n" );
  if( fi.isSymLink() )
	debug( "is a symbolic link and points to %s\n", fi.readLink().data() );

  debug( "The size is %d\n", fi.size() );
  if( fi.isReadable() )
	debug( "is readable\n" );
  else
	debug( "is not readable\n" );
  if( fi.isWritable() )
	debug( "is writable\n" );
  else
	debug( "is not writable\n" );
  if( fi.isExecutable() )
	debug( "is executable\n" );
  else
        debug( "is not executable\n" );

  if( fi.owner() )
	debug( "is owned by %s\n", fi.owner() );
  if( fi.group() )
	debug( "belongs to group %s\n",fi.group() );

  debug( "was last modified at %s\n", fi.lastModified().toString().data() );
  debug( "was last read at %s", fi.lastRead().toString().data() );

  return 0;
}


