/*
 * $Id: qkbrowser.h,v 1.2 1998/01/07 17:49:37 kalle Exp $
 */

#ifndef _QKBROWSER_H
#define _QKBROWSER_H

#include <qwidget.h>
#include <qtableview.h>
#include <qarray.h>

class QString;
class QPainter;
class QPixmap;

class QKBrowseBox : public QTableView
{
  Q_OBJECT
public:
  QKBrowseBox( int x, int y, 
			  QWidget* parent=0, const char* name=0, WFlags f=0 );
  ~QKBrowseBox();
  
  void insertItem( const char* text, int x, int y )
  void insertItem( QPixmap pixmap, int x, int y );
  void removeItem( int x, int y );
  void clear();

  QString text( int x, int y );
  QPixmap pixmap( int x, int y);

  int exec( const QPoint& pos );
  int exec( int x, int y );
  int exec( const QWidget* trigger );

signals:
  void selected( int, int );

protected:
  virtual void keyPressEvent( QKeyEvent* e );
  virtual void resizeEvent( QResizeEvent* e );
  virtual void mouseReleaseEvent( QMouseEvent* e );
  virtual void mouseMoveEvent( QMouseEvent* e );
  virtual void paintCell( QPainter *, int, int );

private:
  int coordsToIndex( int x, int y );

  QString* _texts;
  QPixmap* _pixmaps;
  QPoint _activecell;
  bool _firstrelease;
};

#endif
