#ifndef _QKCOORDSEL_H
#define _QKCOORDSEL_H

#include <qwidget.h>
#include <qrangecontrol.h>
#include <qpoint.h>

class QKCoordSel : public QWidget
{
  Q_OBJECT

public:
  QKCoordSel( QWidget* parent = 0, const char* name = 0, WFlags flags = 0 );
  virtual ~QKCoordSel();

  int xMinValue() const;
  int yMinValue() const;
  int xMaxValue() const;
  int yMaxValue() const;
  QPoint value() const;

  virtual QSize sizeHint() const;
  virtual void setFont( const QFont& );

public slots:
  void setXMinValue( int );
  void setXMaxValue( int );
  void setYMinValue( int );
  void setYMaxValue( int );
  void setValue( int, int );
  void setValue( const QPoint& );

signals:
  void valueChanged( int, int );

protected:
  virtual void paintEvent( QPaintEvent* );
  virtual void mousePressEvent( QMouseEvent* );
  virtual void mouseReleaseEvent( QMouseEvent* );
  virtual void mouseMoveEvent( QMouseEvent* );
  virtual void resizeEvent( QResizeEvent* );

protected:
  QPoint mouseToLogical( QPoint );
  int labelHeight();
  void computeRatio();

private:
  QRangeControl _xrange;
  QRangeControl _yrange;
  QPoint _tempvalue;
  int _labelheight;
  double _xratio, _yratio;
};

#endif
